from __future__ import with_statement

import Queue
import random
import socket
from threading import Thread
from time import sleep
import os
from datetime import datetime
import math
import select
from hashlib import sha256
import struct
import subprocess

class Mine:

    def __init__(self):
        self.init_sleep_time = 60
        # self.pool = multiprocessing.Pool(10)
        self.connection_list = []
        self.outputs = []
        self.message_queues = {}
        self.potential_blocks = Queue.Queue()
        self.miner_ip = socket.gethostbyname(socket.gethostname())
        self.target = ''
        with open('target', 'rb') as f:
            self.target = f.read()

    def do(self):
        peer_ips = []
        with open('peer_list.txt') as f:
            for peer_ip in f:
                peer_ips.append(peer_ip[:-1])

        self.manage_connections(peer_ips)

        self.produce_webcoin_block()




    def manage_connections(self, peer_ips):

        manual_config = True
        peer_ips = []

        if manual_config:
            if peer_ips:
                init_sleep_time = 5
                sleep(init_sleep_time)
                for peer_ip in peer_ips:
                    try:
                        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
                        s.connect((peer_ip, 3536))
                        self.connection_list.append((s, (peer_ip, 3635)))
                    except socket.error, e:
                        print e
                        print('error connecting')
            else:
                self.add_inbound_connections()
        else:
            for peer_ip in peer_ips:
                try:
                    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
                    s.connect((peer_ip, 3536))
                    self.connection_list.append((s,(peer_ip,3635)))
                except:
                    print('error connecting')

            self.add_inbound_connections()

    def add_inbound_connections(self):
        thread = Thread(target=listen_on_socket, args=(self.connection_list,self.outputs, self.message_queues, self.potential_blocks))
        thread.start()
        print('continued...')

    def produce_webcoin_block(self):

        with open("prev_blocks_hash", "rb") as f:
            byte = f.read()

        with open("raw_block", "rb") as f:
            raw_block = f.read()

        if self.potential_blocks.empty():
            with open("prev_block", "rb") as f:
                prev_block = f.read()
        else:
            prev_block = self.potential_blocks.get_nowait()

        subprocess.call("./restart_scrapy.sh")

        prev_second = 0

        while True:

            if math.floor((datetime.utcnow() - datetime(1970, 1, 1)).total_seconds()) <= prev_second and self.potential_blocks.empty():
                sleep(0.1)
                continue

            if math.floor((datetime.utcnow() - datetime(1970, 1, 1)).total_seconds()) > prev_second:
                prev_second += 1

            if not self.potential_blocks.empty():
                prev_block = self.potential_blocks.get_nowait()

            to_check = sha256(sha256(
                binary(math.floor((datetime.utcnow() - datetime(1970, 1, 1)).total_seconds())) +
                binary(prev_block[-(257 + 15 + 8):-(257 + 15)]) +
                byte[-32 * 256:-31 * 256] +
                self.miner_ip
            ).digest()).digest()

            bits = tobits(to_check)[:-1]
            blocks_i = []
            perm = []
            for i in range(51):
                block_i = int(frombits(bits[i*5:(i+1)*5]))
                x = tobits(byte[-block_i*(257 + 15 + 8+256):-block_i*(257 + 15 + 8)])
                perm.append(frombits(x[:118]))
                perm.append(frombits(x[119:236]))
                blocks_i.append([block_i,])

            for per in perm:
                random.seed(per)
                i_s = [x for x in range(32)]
                j_s = [random.choice(i_s) for x in range(32)]
                any_s = [byte[-j*(257 + 15 + 8):-j*(257 + 15 + 8+ 1)] for j in j_s]

            checked = sha256(sha256(''.join(any_s)).digest()).digest()

            if checked < self.target:
                for q in self.message_queues:
                    q.put(raw_block)
                with open("scrapy_hash_for_path", "wb") as f:
                        f.write(byte[-32 * 256:-31 * 256])
                with open("prev_block", "wb") as f:
                        f.write(raw_block)
                with open("raw_block", "rb") as f:
                    raw_block = f.read()

                subprocess.call("./restart_scrapy.sh")




def listen_on_socket(inputs, outputs, message_queues, new_block):
    server = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    server.setblocking(0)
    server.bind((socket.gethostname(), 3536))
    server.listen(200)
    inputs.append(server)
    seen_blocks = []

    while inputs:
        readable, writable, exceptional = select.select(
            inputs, outputs, inputs)
        for s in readable:
            if s is server:
                connection, client_address = s.accept()
                connection.setblocking(0)
                inputs.append(connection)
                message_queues[connection] = Queue.Queue()
            else:
                data = s.recv(16384)
                if data:
                    hashed_data = sha256(sha256(data).digest()).digest()
                    if data not in seen_blocks:
                        new_block.put(data)
                        with open("prev_blocks_hash", "ab") as f:
                            f.write(hashed_data)
                        seen_blocks.append(data)
                        message_queues[s].put(data)
                        if s not in outputs:
                            outputs.append(s)
                else:
                    if s in outputs:
                        outputs.remove(s)
                    inputs.remove(s)
                    s.close()
                    del message_queues[s]

        for s in writable:
            try:
                next_msg = message_queues[s].get_nowait()
            except Queue.Empty:
                outputs.remove(s)
            else:
                s.send(next_msg)

        for s in exceptional:
            inputs.remove(s)
            if s in outputs:
                outputs.remove(s)
            s.close()
            del message_queues[s]


def binary(num):
    return ''.join(bin(ord(c)).replace('0b', '').rjust(8, '0') for c in struct.pack('!f', num))


def tobits(s):
    result = []
    for c in s:
        bits = bin(ord(c))[2:]
        bits = '00000000'[len(bits):] + bits
        result.extend([int(b) for b in bits])
    return result

def frombits(bits):
    chars = []
    for b in range(len(bits) / 8):
        byte = bits[b*8:(b+1)*8]
        chars.append(chr(int(''.join([str(bit) for bit in byte]), 2)))
    return ''.join(chars)