# -*- coding: utf-8 -*-

# Scrapy settings for tutorial project
#
# For simplicity, this file contains only settings considered important or
# commonly used. You can find more settings consulting the documentation:
#
#     http://doc.scrapy.org/en/latest/topics/settings.html
#     http://scrapy.readthedocs.org/en/latest/topics/downloader-middleware.html
#     http://scrapy.readthedocs.org/en/latest/topics/spider-middleware.html

BOT_NAME = 'itzy_bitzy_project'

SPIDER_MODULES = ['itzy_bitzy_project.spiders']
NEWSPIDER_MODULE = 'itzy_bitzy_project.spiders'


CONCURRENT_REQUESTS = 2000
REACTOR_THREADPOOL_MAXSIZE = 100
# LOG_FORMATTER = 'apps.crawler.spiders.PoliteLogFormatter'
LOG_FORMATTER = 'scrapy_projects.itzy_bitzy_project.logformatter.PoliteLogFormatter'
LOG_LEVEL = 'INFO'
DEPTH_PRIORITY = -1 # positive number will cause BFS, negative will cause DFS
COOKIES_ENABLED = False
DOWNLOAD_TIMEOUT = 60
REDIRECT_ENABLED = False
AJAXCRAWL_ENABLED = True

# MONGO_URI = "mongodb://localhost"
# MONGO_DATABASE = "webcoin"
# # MONGO_URI = "mongodb://localhost/webcoin"
#
# MONGODB_COLLECTION = "questions"


# Crawl responsibly by identifying yourself (and your website) on the user-agent
#USER_AGENT = 'tutorial (+http://www.yourdomain.com)'

# Obey robots.txt rules
ROBOTSTXT_OBEY = False

# Configure maximum concurrent requests performed by Scrapy (default: 16)
#CONCURRENT_REQUESTS = 32

# Configure a delay for requests for the same website (default: 0)
# See http://scrapy.readthedocs.org/en/latest/topics/settings.html#download-delay
# See also autothrottle settings and docs
# DOWNLOAD_DELAY = 0.01
# The download delay setting will honor only one of:
#CONCURRENT_REQUESTS_PER_DOMAIN = 16
#CONCURRENT_REQUESTS_PER_IP = 16

# Disable cookies (enabled by default)
#COOKIES_ENABLED = False

# Disable Telnet Console (enabled by default)
#TELNETCONSOLE_ENABLED = False

# Override the default request headers:
#DEFAULT_REQUEST_HEADERS = {
#   'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
#   'Accept-Language': 'en',
#}

# Enable or disable spider middlewares
# See http://scrapy.readthedocs.org/en/latest/topics/spider-middleware.html
#SPIDER_MIDDLEWARES = {
#    'tutorial.middlewares.MyCustomSpiderMiddleware': 543,
#}

# Enable or disable downloader middlewares
# See http://scrapy.readthedocs.org/en/latest/topics/downloader-middleware.html
#DOWNLOADER_MIDDLEWARES = {
#    'tutorial.middlewares.MyCustomDownloaderMiddleware': 543,
#}

# Enable or disable extensions
# See http://scrapy.readthedocs.org/en/latest/topics/extensions.html
#EXTENSIONS = {
#    'scrapy.extensions.telnet.TelnetConsole': None,
#}

# Configure item pipelines
# See http://scrapy.readthedocs.org/en/latest/topics/item-pipeline.html



# COMMENT OUT FOR VERIFICATION TIME
# ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
ITEM_PIPELINES = {
   'itzy_bitzy_project.pipelines.FilterAndStatsPipeline': 280,
   'itzy_bitzy_project.pipelines.AddStartURLsPipeline': 290,
  'itzy_bitzy_project.pipelines.CreateIndexPipeline': 295,
   'itzy_bitzy_project.pipelines.KeepSpiderAlivePipeline': 300,
}
# ------------------------------------------------------------------------------------------------------------------------------------------------------------------------





# Enable and configure the AutoThrottle extension (disabled by default)
# See http://doc.scrapy.org/en/latest/topics/autothrottle.html
#AUTOTHROTTLE_ENABLED = True
# The initial download delay
#AUTOTHROTTLE_START_DELAY = 5
# The maximum download delay to be set in case of high latencies
#AUTOTHROTTLE_MAX_DELAY = 60
# The average number of requests Scrapy should be sending in parallel to
# each remote server
#AUTOTHROTTLE_TARGET_CONCURRENCY = 1.0
# Enable showing throttling stats for every response received:
#AUTOTHROTTLE_DEBUG = False

# Enable and configure HTTP caching (disabled by default)
# See http://scrapy.readthedocs.org/en/latest/topics/downloader-middleware.html#httpcache-middleware-settings
#HTTPCACHE_ENABLED = True
#HTTPCACHE_EXPIRATION_SECS = 0
#HTTPCACHE_DIR = 'httpcache'
#HTTPCACHE_IGNORE_HTTP_CODES = []
#HTTPCACHE_STORAGE = 'scrapy.extensions.httpcache.FilesystemCacheStorage'
