import pickle
import random
from datetime import datetime
from time import sleep

import scrapy
from scrapy import signals
from pymongo import MongoClient

mongo_ip = 'localhost' # XXX update at node
mongo_uri = "mongodb://" + mongo_ip
mongo_db_name = "webcoin"
mongo_client = MongoClient(mongo_uri)
mongo_db = mongo_client[mongo_db_name]

index_sizes_list = [2000]


class VerificationSpider(scrapy.Spider):
    name = "verificationtimespider"


    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.crawlerProcess = kwargs['crawlerProcess']
        self.bw = kwargs['bw']
        self.index_size = random.choice(index_sizes_list)
        print('selected index size: %s' % self.index_size)

    def parse(self, response):
        pass


    def start_requests(self):
        with open('urls_list.pk', 'rb') as f:
            urls_list = pickle.load(f)

        urls = set()
        while len(urls) < self.index_size:
            urls.update(random.choice(urls_list))
        urls = list(urls)[:self.index_size]
        self.verification_start_time = datetime.now()
        return [self.make_requests_from_url(url) for url in urls]

    @classmethod
    def from_crawler(cls, crawler, *args, **kwargs):
        spider = super(VerificationSpider, cls).from_crawler(crawler, *args, **kwargs)
        # crawler.signals.connect(spider.spider_closed, signal=signals.spider_closed)
        return spider


    # def spider_closed(self, spider):
    #     verification_end_time = datetime.now()
    #     total_seconds = (verification_end_time - self.verification_start_time).total_seconds()
    #     print('total_seconds: %s' %total_seconds)
    #     time_stats = {
    #         'total_seconds': total_seconds,
    #         'bw': self.bw,
    #         'index_size': self.index_size,
    #     }
    #     mongo_db.verification_times.insert(time_stats)
    #
    #     self.crawlerProcess.crawl('verificationtimespider', bw=self.bw, crawlerProcess=self.crawlerProcess)